<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref } from 'vue';
import { checkFileExtension, checkType } from '@/lib/utils';
import Button from "@/components/general/Button.vue";
//import Tooltip from "@/components/general/Tooltip.vue";

const props = defineProps<{
    modelValue: any,
    header?: string,
    error?: string,
    label?: string,
    accept: string,
    fileSize?: number,
    showIcon?: boolean
}>();

const emits = defineEmits<{
    (e: 'update:modelValue', value: any): void,
    (e: 'error', value: boolean): void
}>();

const showTextError = ref(false);
const fileName = ref('');

const handleUpload = (event: any) => {
    showTextError.value = false;
    const files = event.target.files;
    if (files[0] !== null &&
        (checkFileExtension(props.accept, files[0].name) || checkType(props.accept, files[0].type)) &&
        (props.fileSize ? files[0].size <= props.fileSize : true)) {
        const fileReader = new FileReader();
        fileReader.readAsDataURL(files[0]);
        let file = files[0];
        fileName.value = file.name;
        emits('update:modelValue', file);
        event.target.value = "";
    } else {
        showTextError.value = true;
        emits('error', true);
    }
}

/*const checkType = (fileType:string) => {
    const validMimeTypes = props.accept.split(',').map((item:string)=>item.replace(/\s+/g,'').replace('/*','').replace('.*','')).filter((item:string)=>item[0]!=='.');
    return validMimeTypes.find((type:string)=>fileType.includes(type))!==undefined;
};

const checkFileExtension = (fileName:string)=>{
    const validFileExtension = props.accept.split(',').filter((item:string)=>item[0]==='.');
    return validFileExtension.find((ext:string)=>fileName.includes(ext));
}*/
const fileUploadRef = ref<HTMLElement>();
const handleButton = () => {
    if (fileUploadRef.value)
        fileUploadRef.value.click();
};

</script>
<template>
    <div>
        <label v-if="header">{{ header }}: <span class="text-orange-400">{{ fileName }}</span></label>
        <div class="flex flex-row gap-2">
            <label :class="[showIcon ? 'w-fit' : 'w-full']">
                <Button variant="cancel" size="small" @click="handleButton">
                    <Tooltip :tooltip="$t('tooltips.upload')"><i class="ri-upload-cloud-2-line ri-xl"
                            v-if="showIcon"></i></Tooltip>{{ label }}
                </Button>
                <input ref="fileUploadRef" type="file" @change="handleUpload" hidden>
            </label>
        </div>
        <p class="text-orange-400 mt-2" v-if="showTextError && error">{{ error }}</p>
    </div>
</template>